Bump version number for 1.9.9.
[bpt/guile.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2010 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?= $(srcdir)/build-aux
26
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
29 gzip_rsyncable := \
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
31 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
32
33 GIT = git
34 VC = $(GIT)
35 VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
36
37 VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
38
39 # You can override this variable in cfg.mk to set your own regexp
40 # matching files to ignore.
41 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
42
43 # This is to preprocess robustly the output of $(VC_LIST), so that even
44 # when $(srcdir) is a pathological name like "....", the leading sed command
45 # removes only the intended prefix.
46 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
47
48 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
49 # when $(srcdir) is not ".".
50 ifeq ($(srcdir),.)
51 _prepend_srcdir_prefix =
52 else
53 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
54 endif
55
56 # In order to be able to consistently filter "."-relative names,
57 # (i.e., with no $(srcdir) prefix), this definition is careful to
58 # remove any $(srcdir) prefix, and to restore what it removes.
59 VC_LIST_EXCEPT = \
60 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
61 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
62 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
63 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
64 $(_prepend_srcdir_prefix)
65
66 ifeq ($(origin prev_version_file), undefined)
67 prev_version_file = $(srcdir)/.prev-version
68 endif
69
70 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
71 VERSION_REGEXP = $(subst .,\.,$(VERSION))
72 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
73
74 ifeq ($(VC),$(GIT))
75 this-vc-tag = v$(VERSION)
76 this-vc-tag-regexp = v$(VERSION_REGEXP)
77 else
78 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
79 tag-this-version = $(subst .,_,$(VERSION))
80 this-vc-tag = $(tag-package)-$(tag-this-version)
81 this-vc-tag-regexp = $(this-vc-tag)
82 endif
83 my_distdir = $(PACKAGE)-$(VERSION)
84
85 # Old releases are stored here.
86 release_archive_dir ?= ../release
87
88 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
89 # Use alpha.gnu.org for alpha and beta releases.
90 # Use ftp.gnu.org for stable releases.
91 gnu_ftp_host-alpha = alpha.gnu.org
92 gnu_ftp_host-beta = alpha.gnu.org
93 gnu_ftp_host-stable = ftp.gnu.org
94 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
95
96 ifeq ($(gnu_rel_host),ftp.gnu.org)
97 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
98 else
99 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
100 endif
101
102 # Override this in cfg.mk if you are using a different format in your
103 # NEWS file.
104 today = $(shell date +%Y-%m-%d)
105 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
106
107 # Prevent programs like 'sort' from considering distinct strings to be equal.
108 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
109 export LC_ALL = C
110
111 ## --------------- ##
112 ## Sanity checks. ##
113 ## --------------- ##
114
115 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
116
117 # Collect the names of rules starting with `sc_'.
118 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
119 $(srcdir)/$(ME) $(_cfg_mk)))
120 .PHONY: $(syntax-check-rules)
121
122 local-checks-available = \
123 $(syntax-check-rules)
124 .PHONY: $(local-checks-available)
125
126 # Arrange to print the name of each syntax-checking rule just before running it.
127 $(syntax-check-rules): %: %.m
128 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
129 .PHONY: $(sc_m_rules_)
130 $(sc_m_rules_):
131 @echo $(patsubst sc_%.m, %, $@)
132
133 local-check := $(filter-out $(local-checks-to-skip), $(local-checks-available))
134
135 syntax-check: $(local-check)
136 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
137 # $$(find -type f -name '*.[chly]') && \
138 # { echo '$(ME): found conditional include' 1>&2; \
139 # exit 1; } || :
140
141 # grep -nE '^# *include <(string|stdlib)\.h>' \
142 # $(srcdir)/{lib,src}/*.[chy] && \
143 # { echo '$(ME): FIXME' 1>&2; \
144 # exit 1; } || :
145 # FIXME: don't allow `#include .strings\.h' anywhere
146
147 # By default, _prohibit_regexp does not ignore case.
148 export ignore_case =
149 _ignore_case = $$(test -n "$$ignore_case" && echo -i || :)
150
151 # There are many rules below that prohibit constructs in this package.
152 # If the offending construct can be matched with a grep-E-style regexp,
153 # use this macro. The shell variables "re" and "msg" must be defined.
154 define _prohibit_regexp
155 dummy=; : so we do not need a semicolon before each use; \
156 test "x$$re" != x || { echo '$(ME): re not defined' 1>&2; exit 1; }; \
157 test "x$$msg" != x || { echo '$(ME): msg not defined' 1>&2; exit 1; };\
158 grep $(_ignore_case) -nE "$$re" $$($(VC_LIST_EXCEPT)) && \
159 { echo '$(ME): '"$$msg" 1>&2; exit 1; } || :
160 endef
161
162 sc_avoid_if_before_free:
163 @$(build_aux)/useless-if-before-free \
164 $(useless_free_options) \
165 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
166 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
167 exit 1; } || :
168
169 sc_cast_of_argument_to_free:
170 @re='\<free *\( *\(' msg='don'\''t cast free argument' \
171 $(_prohibit_regexp)
172
173 sc_cast_of_x_alloc_return_value:
174 @re='\*\) *x(m|c|re)alloc\>' \
175 msg='don'\''t cast x*alloc return value' \
176 $(_prohibit_regexp)
177
178 sc_cast_of_alloca_return_value:
179 @re='\*\) *alloca\>' msg='don'\''t cast alloca return value' \
180 $(_prohibit_regexp)
181
182 sc_space_tab:
183 @re='[ ] ' msg='found SPACE-TAB sequence; remove the SPACE' \
184 $(_prohibit_regexp)
185
186 # Don't use *scanf or the old ato* functions in `real' code.
187 # They provide no error checking mechanism.
188 # Instead, use strto* functions.
189 sc_prohibit_atoi_atof:
190 @re='\<([fs]?scanf|ato([filq]|ll)) *\(' \
191 msg='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
192 $(_prohibit_regexp)
193
194 # Use STREQ rather than comparing strcmp == 0, or != 0.
195 sc_prohibit_strcmp:
196 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
197 $$($(VC_LIST_EXCEPT)) \
198 | grep -vE ':# *define STREQ\(' && \
199 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
200 1>&2; exit 1; } || :
201
202 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
203 # Convert all uses automatically, via these two commands:
204 # git grep -l '\<exit *(1)' \
205 # | grep -vEf .x-sc_prohibit_magic_number_exit \
206 # | xargs --no-run-if-empty \
207 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
208 # git grep -l '\<exit *(0)' \
209 # | grep -vEf .x-sc_prohibit_magic_number_exit \
210 # | xargs --no-run-if-empty \
211 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
212 sc_prohibit_magic_number_exit:
213 @re='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
214 msg='use EXIT_* values rather than magic number' \
215 $(_prohibit_regexp)
216
217 # Using EXIT_SUCCESS as the first argument to error is misleading,
218 # since when that parameter is 0, error does not exit. Use `0' instead.
219 sc_error_exit_success:
220 @grep -nE 'error \(EXIT_SUCCESS,' \
221 $$($(VC_LIST_EXCEPT) | grep -E '\.[chly]$$') && \
222 { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; exit 1; } || :
223
224 # `FATAL:' should be fully upper-cased in error messages
225 # `WARNING:' should be fully upper-cased, or fully lower-cased
226 sc_error_message_warn_fatal:
227 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
228 | grep -E '"Warning|"Fatal|"fatal' && \
229 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
230 exit 1; } || :
231
232 # Error messages should not start with a capital letter
233 sc_error_message_uppercase:
234 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
235 | grep -E '"[A-Z]' \
236 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
237 { echo '$(ME): found capitalized error message' 1>&2; \
238 exit 1; } || :
239
240 # Error messages should not end with a period
241 sc_error_message_period:
242 @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT)) \
243 | grep -E '[^."]\."' && \
244 { echo '$(ME): found error message ending in period' 1>&2; \
245 exit 1; } || :
246
247 sc_file_system:
248 @re=file''system ignore_case=1 \
249 msg='found use of "file''system"; spell it "file system"' \
250 $(_prohibit_regexp)
251
252 # Don't use cpp tests of this symbol. All code assumes config.h is included.
253 sc_prohibit_have_config_h:
254 @grep -n '^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT)) && \
255 { echo '$(ME): found use of HAVE''_CONFIG_H; remove' \
256 1>&2; exit 1; } || :
257
258 # Nearly all .c files must include <config.h>. However, we also permit this
259 # via inclusion of a package-specific header, if cfg.mk specified one.
260 # config_h_header must be suitable for grep -E.
261 config_h_header ?= <config\.h>
262 sc_require_config_h:
263 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
264 grep -EL '^# *include $(config_h_header)' \
265 $$($(VC_LIST_EXCEPT) | grep '\.c$$') \
266 | grep . && \
267 { echo '$(ME): the above files do not include <config.h>' \
268 1>&2; exit 1; } || :; \
269 else :; \
270 fi
271
272 # You must include <config.h> before including any other header file.
273 # This can possibly be via a package-specific header, if given by cfg.mk.
274 sc_require_config_h_first:
275 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
276 fail=0; \
277 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
278 grep '^# *include\>' $$i | sed 1q \
279 | grep -E '^# *include $(config_h_header)' > /dev/null \
280 || { echo $$i; fail=1; }; \
281 done; \
282 test $$fail = 1 && \
283 { echo '$(ME): the above files include some other header' \
284 'before <config.h>' 1>&2; exit 1; } || :; \
285 else :; \
286 fi
287
288 sc_prohibit_HAVE_MBRTOWC:
289 @re='\bHAVE_MBRTOWC\b' msg="do not use $$re; it is always defined" \
290 $(_prohibit_regexp)
291
292 # To use this "command" macro, you must first define two shell variables:
293 # h: the header, enclosed in <> or ""
294 # re: a regular expression that matches IFF something provided by $h is used.
295 define _header_without_use
296 dummy=; : so we do not need a semicolon before each use; \
297 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
298 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
299 files=$$(grep -l '^# *include '"$$h_esc" \
300 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
301 grep -LE "$$re" $$files | grep . && \
302 { echo "$(ME): the above files include $$h but don't use it" \
303 1>&2; exit 1; } || :; \
304 else :; \
305 fi
306 endef
307
308 # Prohibit the inclusion of assert.h without an actual use of assert.
309 sc_prohibit_assert_without_use:
310 @h='<assert.h>' re='\<assert *\(' $(_header_without_use)
311
312 # Prohibit the inclusion of close-stream.h without an actual use.
313 sc_prohibit_close_stream_without_use:
314 @h='"close-stream.h"' re='\<close_stream *\(' $(_header_without_use)
315
316 # Prohibit the inclusion of getopt.h without an actual use.
317 sc_prohibit_getopt_without_use:
318 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_header_without_use)
319
320 # Don't include quotearg.h unless you use one of its functions.
321 sc_prohibit_quotearg_without_use:
322 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_header_without_use)
323
324 # Don't include quote.h unless you use one of its functions.
325 sc_prohibit_quote_without_use:
326 @h='"quote.h"' re='\<quote(_n)? *\(' $(_header_without_use)
327
328 # Don't include this header unless you use one of its functions.
329 sc_prohibit_long_options_without_use:
330 @h='"long-options.h"' re='\<parse_long_options *\(' \
331 $(_header_without_use)
332
333 # Don't include this header unless you use one of its functions.
334 sc_prohibit_inttostr_without_use:
335 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
336 $(_header_without_use)
337
338 # Don't include this header unless you use one of its functions.
339 sc_prohibit_ignore_value_without_use:
340 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
341 $(_header_without_use)
342
343 # Don't include this header unless you use one of its functions.
344 sc_prohibit_error_without_use:
345 @h='"error.h"' \
346 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
347 $(_header_without_use)
348
349 # Don't include xalloc.h unless you use one of its functions.
350 # Consider these symbols:
351 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
352 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) \(/ and print $1' lib/xalloc.h
353 # Divide into two sets on case, and filter each through this:
354 # | sort | perl -MRegexp::Assemble -le \
355 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
356 # Note this was produced by the above:
357 # _xa1 = \
358 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
359 # But we can do better, in at least two ways:
360 # 1) take advantage of two "dup"-suffixed strings:
361 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
362 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
363 # "char|[cmz]"
364 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
365 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
366 _xa2 = X([CZ]|N?M)ALLOC
367 sc_prohibit_xalloc_without_use:
368 @h='"xalloc.h"' \
369 re='\<($(_xa1)|$(_xa2)) *\('\
370 $(_header_without_use)
371
372 # Extract function names:
373 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) \(/ and print $1' lib/hash.h
374 _hash_re = \
375 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
376 _hash_fn = \<($(_hash_re)) *\(
377 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
378 sc_prohibit_hash_without_use:
379 @h='"hash.h"' \
380 re='$(_hash_fn)|$(_hash_struct)'\
381 $(_header_without_use)
382
383 sc_prohibit_hash_pjw_without_use:
384 @h='"hash-pjw.h"' \
385 re='\<hash_pjw *\(' \
386 $(_header_without_use)
387
388 sc_prohibit_safe_read_without_use:
389 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
390 $(_header_without_use)
391
392 sc_prohibit_argmatch_without_use:
393 @h='"argmatch.h"' \
394 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
395 $(_header_without_use)
396
397 sc_prohibit_canonicalize_without_use:
398 @h='"canonicalize.h"' \
399 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
400 $(_header_without_use)
401
402 sc_prohibit_root_dev_ino_without_use:
403 @h='"root-dev-ino.h"' \
404 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
405 $(_header_without_use)
406
407 sc_prohibit_openat_without_use:
408 @h='"openat.h"' \
409 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
410 $(_header_without_use)
411
412 # Prohibit the inclusion of c-ctype.h without an actual use.
413 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
414 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
415 sc_prohibit_c_ctype_without_use:
416 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' $(_header_without_use)
417
418 _empty =
419 _sp = $(_empty) $(_empty)
420 # The following list was generated by running:
421 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
422 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
423 _sig_functions = \
424 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
425 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
426 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
427 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
428 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
429 # The following were extracted from "man signal.h" manually.
430 _sig_types_and_consts = \
431 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
432 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
433 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
434 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
435 sigstack sigval stack_t ucontext_t
436 # generated via this:
437 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
438 _sig_names = \
439 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
440 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
441 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
442 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
443 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
444 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
445 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
446 SIGXCPU SIGXFSZ
447 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
448
449 # Prohibit the inclusion of signal.h without an actual use.
450 sc_prohibit_signal_without_use:
451 @h='<signal.h>' \
452 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
453 $(_header_without_use)
454
455 sc_obsolete_symbols:
456 @re='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
457 msg='do not use HAVE''_FCNTL_H or O'_NDELAY \
458 $(_prohibit_regexp)
459
460 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
461
462 # Each nonempty ChangeLog line must start with a year number, or a TAB.
463 sc_changelog:
464 @if $(VC_LIST_EXCEPT) | grep -l '^ChangeLog$$' >/dev/null; then \
465 grep -n '^[^12 ]' \
466 $$($(VC_LIST_EXCEPT) | grep '^ChangeLog$$') && \
467 { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
468 exit 1; } || :; \
469 fi
470
471 # Ensure that each .c file containing a "main" function also
472 # calls set_program_name.
473 sc_program_name:
474 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
475 files=$$(grep -l '^main *(' $$($(VC_LIST_EXCEPT) | grep '\.c$$')); \
476 grep -LE 'set_program_name *\(m?argv\[0\]\);' $$files \
477 | grep . && \
478 { echo '$(ME): the above files do not call set_program_name' \
479 1>&2; exit 1; } || :; \
480 else :; \
481 fi
482
483 # Require that the final line of each test-lib.sh-using test be this one:
484 # Exit $fail
485 # Note: this test requires GNU grep's --label= option.
486 Exit_witness_file ?= tests/test-lib.sh
487 Exit_base := $(notdir $(Exit_witness_file))
488 sc_require_test_exit_idiom:
489 @if test -f $(srcdir)/$(Exit_witness_file); then \
490 die=0; \
491 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
492 $$($(VC_LIST) tests)); do \
493 tail -n1 $$i | grep '^Exit .' > /dev/null \
494 && : || { die=1; echo $$i; } \
495 done; \
496 test $$die = 1 && \
497 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
498 echo 1>&2 'Exit something'; \
499 exit 1; } || :; \
500 fi
501
502 sc_the_the:
503 @re='\<the ''the\>' \
504 ignore_case=1 msg='found use of "the ''the";' \
505 $(_prohibit_regexp)
506
507 sc_trailing_blank:
508 @re='[ ]$$' \
509 msg='found trailing blank(s)' \
510 $(_prohibit_regexp)
511
512 # Match lines like the following, but where there is only one space
513 # between the options and the description:
514 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
515 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
516 sc_two_space_separator_in_usage:
517 @grep -nE '^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
518 $$($(VC_LIST_EXCEPT)) && \
519 { echo "$(ME): help2man requires at least two spaces between"; \
520 echo "$(ME): an option and its description"; \
521 1>&2; exit 1; } || :
522
523 # Look for diagnostics that aren't marked for translation.
524 # This won't find any for which error's format string is on a separate line.
525 sc_unmarked_diagnostics:
526 @grep -nE \
527 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
528 | grep -v '_''(' && \
529 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
530 exit 1; } || :
531
532 # Avoid useless parentheses like those in this example:
533 # #if defined (SYMBOL) || defined (SYM2)
534 sc_useless_cpp_parens:
535 @grep -n '^# *if .*defined *(' $$($(VC_LIST_EXCEPT)) && \
536 { echo '$(ME): found useless parentheses in cpp directive' \
537 1>&2; exit 1; } || :
538
539 # Require the latest GPL.
540 sc_GPL_version:
541 @re='either ''version [^3]' msg='GPL vN, N!=3' \
542 $(_prohibit_regexp)
543
544 # Require the latest GFDL. Two regexp, since some .texi files end up
545 # line wrapping between 'Free Documentation License,' and 'Version'.
546 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
547 sc_GFDL_version:
548 @re='$(_GFDL_regexp)' msg='GFDL vN, N!=3' \
549 $(_prohibit_regexp)
550
551 cvs_keywords = \
552 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
553
554 sc_prohibit_cvs_keyword:
555 @re='\$$($(cvs_keywords))\$$' \
556 msg='do not use CVS keyword expansion' \
557 $(_prohibit_regexp)
558
559 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
560 # This is a bit of a kludge, since it prevents use of the string
561 # even in comments, but for now it does the job with no false positives.
562 sc_prohibit_stat_st_blocks:
563 @re='[.>]st_blocks' msg='do not use st_blocks; use ST_NBLOCKS' \
564 $(_prohibit_regexp)
565
566 # Make sure we don't define any S_IS* macros in src/*.c files.
567 # They're already defined via gnulib's sys/stat.h replacement.
568 sc_prohibit_S_IS_definition:
569 @re='^ *# *define *S_IS' \
570 msg='do not define S_IS* macros; include <sys/stat.h>' \
571 $(_prohibit_regexp)
572
573 # Each program that uses proper_name_utf8 must link with one of the
574 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
575 # The perl -0777 invocation below extracts the possibly-multi-line
576 # definition of LDADD from the appropriate Makefile.am and exits 0
577 # when it contains "ICONV".
578 sc_proper_name_utf8_requires_ICONV:
579 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
580 if test "x$$progs" != x; then \
581 fail=0; \
582 for p in $$progs; do \
583 dir=$$(dirname "$$p"); \
584 perl -0777 \
585 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
586 $$dir/Makefile.am && continue; \
587 base=$$(basename "$$p" .c); \
588 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
589 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
590 done; \
591 test $$fail = 1 && \
592 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
593 exit 1; } || :; \
594 fi
595
596 # Warn about "c0nst struct Foo const foo[]",
597 # but not about "char const *const foo" or "#define const const".
598 sc_redundant_const:
599 @re='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
600 msg='redundant "const" in declarations' \
601 $(_prohibit_regexp)
602
603 sc_const_long_option:
604 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
605 | grep -Ev 'const struct option|struct option const' && { \
606 echo 1>&2 '$(ME): add "const" to the above declarations'; \
607 exit 1; } || :
608
609 NEWS_hash = \
610 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
611 $(srcdir)/NEWS \
612 | perl -0777 -pe \
613 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
614 | md5sum - \
615 | sed 's/ .*//')
616
617 # Ensure that we don't accidentally insert an entry into an old NEWS block.
618 sc_immutable_NEWS:
619 @if test -f $(srcdir)/NEWS; then \
620 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
621 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
622 fi
623
624 # Update the hash stored above. Do this after each release and
625 # for any corrections to old entries.
626 update-NEWS-hash: NEWS
627 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
628 $(srcdir)/cfg.mk
629
630 # Ensure that we use only the standard $(VAR) notation,
631 # not @...@ in Makefile.am, now that we can rely on automake
632 # to emit a definition for each substituted variable.
633 # We use perl rather than "grep -nE ..." to exempt a single
634 # use of an @...@-delimited variable name in src/Makefile.am.
635 # Allow the package to add exceptions via a hook in cfg.mk;
636 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
637 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
638 _makefile_at_at_check_exceptions ?=
639 sc_makefile_at_at_check:
640 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
641 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
642 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
643 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
644
645 news-check: NEWS
646 if head $(srcdir)/NEWS | grep -E $(news-check-regexp) \
647 >/dev/null; then \
648 :; \
649 else \
650 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
651 exit 1; \
652 fi
653
654 sc_makefile_TAB_only_indentation:
655 @grep -nE '^ [ ]{8}' \
656 $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$') \
657 && { echo '$(ME): found TAB-8-space indentation' 1>&2; \
658 exit 1; } || :
659
660 sc_m4_quote_check:
661 @grep -nE '(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
662 $$($(VC_LIST_EXCEPT) | grep -E '(^configure\.ac|\.m4)$$') \
663 && { echo '$(ME): quote the first arg to AC_DEF*' 1>&2; \
664 exit 1; } || :
665
666 fix_po_file_diag = \
667 'you have changed the set of files with translatable diagnostics;\n\
668 apply the above patch\n'
669
670 # Verify that all source files using _() are listed in po/POTFILES.in.
671 po_file = po/POTFILES.in
672 sc_po_check:
673 @if test -f $(po_file); then \
674 grep -E -v '^(#|$$)' $(po_file) \
675 | grep -v '^src/false\.c$$' | sort > $@-1; \
676 files=; \
677 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
678 test -r $$file || continue; \
679 case $$file in \
680 *.m4|*.mk) continue ;; \
681 *.?|*.??) ;; \
682 *) continue;; \
683 esac; \
684 case $$file in \
685 *.[ch]) \
686 base=`expr " $$file" : ' \(.*\)\..'`; \
687 { test -f $$base.l || test -f $$base.y; } && continue;; \
688 esac; \
689 files="$$files $$file"; \
690 done; \
691 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
692 | sort -u > $@-2; \
693 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
694 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
695 rm -f $@-1 $@-2; \
696 fi
697
698 # Sometimes it is useful to change the PATH environment variable
699 # in Makefiles. When doing so, it's better not to use the Unix-centric
700 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
701 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
702 sc_makefile_path_separator_check:
703 @grep -nE 'PATH[=].*:' \
704 $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$') \
705 && { echo $(msg) 1>&2; exit 1; } || :
706
707 # Check that `make alpha' will not fail at the end of the process.
708 writable-files:
709 if test -d $(release_archive_dir); then :; else \
710 for file in $(distdir).tar.gz \
711 $(release_archive_dir)/$(distdir).tar.gz; do \
712 test -e $$file || continue; \
713 test -w $$file \
714 || { echo ERROR: $$file is not writable; fail=1; }; \
715 done; \
716 test "$$fail" && exit 1 || : ; \
717 fi
718
719 v_etc_file = lib/version-etc.c
720 sample-test = tests/sample-test
721 texi = doc/$(PACKAGE).texi
722 # Make sure that the copyright date in $(v_etc_file) is up to date.
723 # Do the same for the $(sample-test) and the main doc/.texi file.
724 sc_copyright_check:
725 @if test -f $(v_etc_file); then \
726 grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
727 >/dev/null \
728 || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
729 exit 1; }; \
730 fi
731 @if test -f $(sample-test); then \
732 grep '# Copyright (C) '$$(date +%Y)' Free' $(sample-test) \
733 >/dev/null \
734 || { echo 'out of date copyright in $(sample-test); update it' 1>&2; \
735 exit 1; }; \
736 fi
737 @if test -f $(texi); then \
738 grep 'Copyright @copyright{} .*'$$(date +%Y)' Free' $(texi) \
739 >/dev/null \
740 || { echo 'out of date copyright in $(texi); update it' 1>&2; \
741 exit 1; }; \
742 fi
743
744 # #if HAVE_... will evaluate to false for any non numeric string.
745 # That would be flagged by using -Wundef, however gnulib currently
746 # tests many undefined macros, and so we can't enable that option.
747 # So at least preclude common boolean strings as macro values.
748 sc_Wundef_boolean:
749 @grep -Ei '^#define.*(yes|no|true|false)$$' '$(CONFIG_INCLUDE)' && \
750 { echo 'Use 0 or 1 for macro values' 1>&2; exit 1; } || :
751
752 sc_vulnerable_makefile_CVE-2009-4029:
753 @files=$$(find $(srcdir) -name Makefile.in); \
754 if test -n "$$files"; then \
755 grep -E \
756 'perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
757 $$files && \
758 { echo '$(ME): the above files are vulnerable; beware of' \
759 'running "make dist*" rules, and upgrade to fixed automake' \
760 'see http://bugzilla.redhat.com/542609 for details' \
761 1>&2; exit 1; } || :; \
762 else :; \
763 fi
764
765 vc-diff-check:
766 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
767 if test -s vc-diffs; then \
768 cat vc-diffs; \
769 echo "Some files are locally modified:" 1>&2; \
770 exit 1; \
771 else \
772 rm vc-diffs; \
773 fi
774
775 rel-files = $(DIST_ARCHIVES)
776
777 gnulib_dir ?= $(srcdir)/gnulib
778 gnulib-version = $$(cd $(gnulib_dir) && git describe)
779 bootstrap-tools ?= autoconf,automake,gnulib
780
781 # If it's not already specified, derive the GPG key ID from
782 # the signed tag we've just applied to mark this release.
783 gpg_key_ID ?= \
784 $$(git cat-file tag v$(VERSION) > .ann-sig \
785 && gpgv .ann-sig - < /dev/null 2>&1 \
786 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
787
788 announcement: NEWS ChangeLog $(rel-files)
789 @$(build_aux)/announce-gen \
790 --release-type=$(RELEASE_TYPE) \
791 --package=$(PACKAGE) \
792 --prev=$(PREV_VERSION) \
793 --curr=$(VERSION) \
794 --gpg-key-id=$(gpg_key_ID) \
795 --news=$(srcdir)/NEWS \
796 --bootstrap-tools=$(bootstrap-tools) \
797 --gnulib-version=$(gnulib-version) \
798 --no-print-checksums \
799 $(addprefix --url-dir=, $(url_dir_list))
800
801 ## ---------------- ##
802 ## Updating files. ##
803 ## ---------------- ##
804
805 ftp-gnu = ftp://ftp.gnu.org/gnu
806 www-gnu = http://www.gnu.org
807
808 upload_dest_dir_ ?= $(PACKAGE)
809 emit_upload_commands:
810 @echo =====================================
811 @echo =====================================
812 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
813 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
814 @echo " $(rel-files)"
815 @echo '# send the ~/announce-$(my_distdir) e-mail'
816 @echo =====================================
817 @echo =====================================
818
819 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
820 define emit-commit-log
821 printf '%s\n' 'post-release administrivia' '' \
822 '* NEWS: Add header line for next release.' \
823 '* .prev-version: Record previous version.' \
824 '* cfg.mk (old_NEWS_hash): Auto-update.'
825 endef
826
827 .PHONY: no-submodule-changes
828 no-submodule-changes:
829 if test -d $(srcdir)/.git; then \
830 diff=$$(cd $(srcdir) && git submodule -q foreach \
831 git diff-index --name-only HEAD) \
832 || exit 1; \
833 case $$diff in '') ;; \
834 *) echo '$(ME): submodule files are locally modified:'; \
835 echo "$$diff"; exit 1;; esac; \
836 else \
837 : ; \
838 fi
839
840 .PHONY: alpha beta stable
841 ALL_RECURSIVE_TARGETS += alpha beta stable
842 alpha beta stable: $(local-check) writable-files no-submodule-changes
843 test $@ = stable \
844 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
845 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
846 || :
847 $(MAKE) vc-diff-check
848 $(MAKE) news-check
849 $(MAKE) distcheck
850 $(MAKE) dist XZ_OPT=-9ev
851 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
852 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
853
854 # Override this in cfg.mk if you follow different procedures.
855 release-prep-hook ?= release-prep
856
857 .PHONY: release-prep
858 release-prep:
859 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
860 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
861 $(MAKE) -s announcement > ~/announce-$(my_distdir)
862 if test -d $(release_archive_dir); then \
863 ln $(rel-files) $(release_archive_dir); \
864 chmod a-w $(rel-files); \
865 fi
866 echo $(VERSION) > $(prev_version_file)
867 $(MAKE) update-NEWS-hash
868 perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
869 $(emit-commit-log) > .ci-msg
870 $(VC) commit -F .ci-msg -a
871 rm .ci-msg
872
873 .PHONY: web-manual
874 web-manual:
875 @test -z "$(manual_title)" \
876 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
877 @cd '$(srcdir)/doc'; \
878 $(SHELL) ../build-aux/gendocs.sh -o '$(abs_builddir)/doc/manual' \
879 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
880 "$(PACKAGE_NAME) - $(manual_title)"
881 @echo " *** Upload the doc/manual directory to web-cvs."
882
883 # Code Coverage
884
885 init-coverage:
886 $(MAKE) $(AM_MAKEFLAGS) clean
887 lcov --directory . --zerocounters
888
889 COVERAGE_CCOPTS ?= "-g --coverage"
890 COVERAGE_OUT ?= doc/coverage
891
892 build-coverage:
893 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
894 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
895 mkdir -p $(COVERAGE_OUT)
896 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
897 --capture
898
899 gen-coverage:
900 genhtml --output-directory $(COVERAGE_OUT) \
901 $(COVERAGE_OUT)/$(PACKAGE).info \
902 --highlight --frames --legend \
903 --title "$(PACKAGE_NAME)"
904
905 coverage: init-coverage build-coverage gen-coverage
906
907 # Update gettext files.
908 PACKAGE ?= $(shell basename $(PWD))
909 PO_DOMAIN ?= $(PACKAGE)
910 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
911 PODIR ?= po
912 refresh-po:
913 rm -f $(PODIR)/*.po && \
914 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
915 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
916 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
917 echo 'en@quot' >> $(PODIR)/LINGUAS && \
918 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
919
920 INDENT_SOURCES ?= $(C_SOURCES)
921 .PHONY: indent
922 indent:
923 indent $(INDENT_SOURCES)
924
925 # If you want to set UPDATE_COPYRIGHT_* environment variables,
926 # put the assignments in this variable.
927 update-copyright-env ?=
928
929 # Run this rule once per year (usually early in January)
930 # to update all FSF copyright year lists in your project.
931 # If you have an additional project-specific rule,
932 # add it in cfg.mk along with a line 'update-copyright: prereq'.
933 # By default, exclude all variants of COPYING; you can also
934 # add exemptions (such as ChangeLog..* for rotated change logs)
935 # in the file .x-update-copyright.
936 .PHONY: update-copyright
937 update-copyright:
938 grep -l -w Copyright \
939 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
940 | $(update-copyright-env) xargs $(build_aux)/$@